#include <avr/io.h>
#include <stdlib.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>

#include "Synth_config.h"
#include "Synthesizer.h"

#define SI_END 		0x80
#define SI_VOLUME	0x81
#define SI_DELAY	0x82
#define SI_SOUND	0x83

#define SEQ_STATE_EN 0

#define seq_start() Seq.state |= (1<<SEQ_STATE_EN)
#define seq_stop() Seq.state &= ~(1<<SEQ_STATE_EN)
#define seq_running() (Seq.state & 1<<SEQ_STATE_EN)

typedef uint8_t (*ReadFunc) (uint8_t*);

uint8_t ReadFlash(uint8_t* pos);

struct
{
	uint8_t* file;
	ReadFunc read;
	uint8_t tempo, tempocounter, state;
} __attribute__ ((packed)) Seq;

int8_t seq_load(ReadFunc read, uint8_t* data);
void synth_set_sound(Oscillator* osc, uint8_t sound);
void synth_set_note(Oscillator* osc, uint8_t note);
