#include "utils.h"

static void lsRowsOfClust_ex (fptr_t uputs_ptr,uint32_t start_sec){

	uint16_t row;				// reihen
	uint8_t sec;				// sektoren
	uint8_t tmp[12];			// tmp string zur umwandlung
	uint8_t i;				// um dateinamen zu lesen

	sec=0;
	do{
		fat_loadSector( start_sec + sec );	// sektoren des clusters laden
		for( row=0; row<512; row+=32 ){		// geht durch reihen des sektors

			if( (fat.sector[row+11]==0x20||fat.sector[row+11]==0x10) && (fat.sector[row]!=0xE5 && fat.sector[row]!=0x00) ){
				
				// namen extrahieren und anzeigen
				for( i=0 ; i<11 ; i++ ){
					tmp[i]=fat.sector[row+i];
				}
				tmp[i]='\0';
				uputs_ptr(tmp);

				// reihe auf file stuct laden um file.length zu bekommen. koverieren und anzeigen...
				/*fat_loadRowOfSector(row);		
				uputs_ptr((uint8_t*)" ");
				ltostr(file.length,(char*)tmp,12,10);
				uputs_ptr(tmp);
				uputs_ptr((uint8_t*)"\n");*/
			}
		}
	}while( ++sec < fat.secPerClust );
}

// *******************************************************************************************************************************
// zeigt inhalt eines direktory an.
// unterscheidung ob man sich im rootDir befindet noetig, weil bei fat16 im root dir eine bestimmt anzahl sektoren durchsucht
// werden muessen und bei fat32 ab einem start cluster ! ruft lsRowsOfClust auf um cluster/sektoren anzuzeigen.
// *******************************************************************************************************************************
void ffls_ex(fptr_t uputs_ptr){

	uint8_t 		sectors;	// variable um durch sektoren zu zaehlen
	uint32_t 	clusters;	// variable um durch cluster des verzeichnisses zu gehen

	// bestimmen ab welchem cluster eintraege angezeigt werden sollen, bzw in welchem ordner man sich befindet
	clusters = (fat.dir==0) ? fat.rootDir:fat.dir;

	// root-dir fat16 nach eintrag durchsuchen. es bleiben noch 3 moeglichkeiten: nicht root-dir fat16, nicht root-dir fat32 und root-dir fat32
	if(fat.dir==0 && fat.fatType==16){
		sectors = 0;
		do{
			// root-dir eintraege anzeigen
			lsRowsOfClust_ex( uputs_ptr, clusters + sectors );
			sectors += fat.secPerClust;
		}while( sectors < (uint8_t)32 );
	}

	// root-dir fat32 oder nicht root-dir fat32/16, nach eintrag durchsuchen
	else {
		// durch cluster des verzeichnisses gehen und eintraege anzeigen
		while(!((clusters>=0x0ffffff8&&fat.fatType==32)||(clusters>=0xfff8&&fat.fatType==16))){		// prueft ob weitere sektoren zum lesen da sind (fat32||fat16)
			lsRowsOfClust_ex( uputs_ptr, fat_clustToSec(clusters) );									// zeigt reihen des clusters an
			clusters = fat_getNextCluster(clusters);												// liest naechsten cluster des dir-eintrags (unterverzeichniss groeßer 16 einträge)
		}
	}

}

void timer0_init(void){

	// Configure debouncing routines
  	KEY_DDR &= ~ALL_KEYS;                // configure key port for input
  	KEY_PORT |= ALL_KEYS;                // and turn on pull up resistors
	
	TimingDelay = 0;		// initialisierung der zaehl variable	

	TCCR0A = 1<<WGM01; 		// timer0 im ctc mode
	TIMSK0 = 1<<OCIE0A;		// compare interrupt an

	OCR0A = F_CPU / 1024 / 100;	// maximum bis wo gezaehlt wird bevor compare match	

	TCCR0B = (1<<CS00) | (1<<CS02);		// wenn prescaler gesetzt wird, lauft timer los (hier 1024)
}

#if (MMC_LS == TRUE)
//*****************************************************************************************************************
int8_t *ltostr(int32_t num, int8_t *string, uint16_t max_chars, uint8_t base)
{
      int8_t remainder;
      int sign = 0;   /* number of digits occupied by the sign. */

      if (base < 2 || base > 36)
            return FALSE;

      if (num < 0)
      {
            sign = 1;
            num = -num;
      }

      string[--max_chars] = '\0';

      for (max_chars--; max_chars > sign && num!=0; max_chars --)
      {
            remainder = (int8_t) (num % base);
            if ( remainder <= 9 )
                  string[max_chars] = remainder + '0';
            else  string[max_chars] = remainder - 10 + 'A';
            num /= base;
      }

      if (sign)
            string[--max_chars] = '-';

      if ( max_chars > 0 )
            memset(string, ' ', max_chars+1);

      return string + max_chars;
}
#endif

/************************************************************************/
/*                                                                      */
/*                      Debouncing 8 Keys                               */
/*                      Sampling 4 Times                                */
/*                      With Repeat Function                            */
/*                                                                      */
/*              Author: Peter Dannegger                                 */
/*                      danni@specs.de                                  */
/*                                                                      */
/************************************************************************/

 
#define REPEAT_MASK     (1<<KEY_RIGHT | 1<<KEY_LEFT)       // repeat: key1, key2
#define REPEAT_START    50                        // after 500ms
#define REPEAT_NEXT     20                        // every 200ms

 
volatile uint8_t key_state;                                // debounced and inverted key state:
                                                  // bit = 1: key pressed
volatile uint8_t key_press;                                // key press detect
 
volatile uint8_t key_rpt;                                  // key long press and repeat
 
///////////////////////////////////////////////////////////////////
//
// check if a key has been pressed. Each pressed key is reported
// only once
//
uint8_t get_key_press( uint8_t key_mask )
{
  cli();                                          // read and clear atomic !
  key_mask &= key_press;                          // read key(s)
  key_press ^= key_mask;                          // clear key(s)
  sei();
  return key_mask;
}
 
///////////////////////////////////////////////////////////////////
//
// check if a key has been pressed long enough such that the
// key repeat functionality kicks in. After a small setup delay
// the key is reported being pressed in subsequent calls
// to this function. This simulates the user repeatedly
// pressing and releasing the key.
//
uint8_t get_key_rpt( uint8_t key_mask )
{
  cli();                                          // read and clear atomic !
  key_mask &= key_rpt;                            // read key(s)
  key_rpt ^= key_mask;                            // clear key(s)
  sei();
  return key_mask;
}
 
///////////////////////////////////////////////////////////////////
//
uint8_t get_key_short( uint8_t key_mask )
{
  cli();                                          // read key state and key press atomic !
  return get_key_press( ~key_state & key_mask );
}
 
///////////////////////////////////////////////////////////////////
//
uint8_t get_key_long( uint8_t key_mask )
{
  return get_key_press( get_key_rpt( key_mask ));
}

// timer0 variable
volatile uint8_t 	TimingDelay;	// fuer mmc.c

ISR (TIMER0_COMPA_vect)
{
	TimingDelay = (TimingDelay==0) ? 0 : TimingDelay-1;

	static uint8_t ct0, ct1, rpt;
	uint8_t i = key_state ^ ~KEY_PIN;                       // key changed ?
	ct0 = ~( ct0 & i );                             // reset or count ct0
	ct1 = ct0 ^ (ct1 & i);                          // reset or count ct1
	i &= ct0 & ct1;                                 // count until roll over ?
	key_state ^= i;                                 // then toggle debounced state
	key_press |= key_state & i;                     // 0->1: key press detect

	if( (key_state & REPEAT_MASK) == 0 )            // check repeat function
	 rpt = REPEAT_START;                          // start delay
	if( --rpt == 0 ){
	rpt = REPEAT_NEXT;                            // repeat delay
	key_rpt |= key_state & REPEAT_MASK;
	}
}

